Index: /trunk/src/sh_hash.c
===================================================================
--- /trunk/src/sh_hash.c	(revision 584)
+++ /trunk/src/sh_hash.c	(revision 1)
@@ -3146,49 +3198,9 @@
   time_t now  = time(NULL);
   time_t then = (time_t) p->theFile.mtime;
-  struct tm   * time_ptr;
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GMTIME_R)
-  struct tm     time_tm;
-#endif
-
-  if (ListFullDetail != S_FALSE)
-    {
-      sh_hash_list_db_entry_full_detail (p);
-      return;
-    }
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GMTIME_R)
-  time_ptr = gmtime_r(&then, &time_tm);
-  if (!time_ptr)
-    return;
-  strftime(thetime, 127, _("%b %d  %Y"), time_ptr);
-  time_ptr = gmtime_r(&now,  &time_tm);
-  if (!time_ptr)
-    return;
-  strftime(nowtime, 127, _("%b %d  %Y"), time_ptr);
+
+  strftime(thetime, 127, _("%b %d  %Y"), gmtime(&then));
+  strftime(nowtime, 127, _("%b %d  %Y"), gmtime(&now));
   if (0 == strncmp(&nowtime[7], &thetime[7], 4))
-    {
-      time_ptr = gmtime_r(&then, &time_tm);
-      if (!time_ptr)
-	return;
-      strftime(thetime, 127, _("%b %d %H:%M"), time_ptr);
-    }
-#else
-  time_ptr = gmtime(&then);
-  if (!time_ptr)
-    return;
-  strftime(thetime, 127, _("%b %d  %Y"), time_ptr);
-  time_ptr = gmtime(&now);
-  if (!time_ptr)
-    return;
-  strftime(nowtime, 127, _("%b %d  %Y"), time_ptr);
-  if (0 == strncmp(&nowtime[7], &thetime[7], 4))
-    {
-      time_ptr = gmtime(&then);
-      if (!time_ptr)
-	return;
-      strftime(thetime, 127, _("%b %d %H:%M"), time_ptr);
-    }
-#endif
+    strftime(thetime, 127, _("%b %d %H:%M"), gmtime(&then));
 
   tmp = sh_util_safe_name(p->fullpath);
@@ -3221,48 +3233,67 @@
 }
 
-#ifdef HAVE_LIBZ
-#include <zlib.h>
-#endif    
-
-int sh_hash_printcontent(char * linkpath)
-{
-#ifdef HAVE_LIBZ
-  unsigned char * decoded;
-  unsigned char * decompressed = NULL;
-  size_t dlen;
-  unsigned long clen;
-  unsigned long clen_o;
-  int    res;
-
-  if (linkpath && *linkpath != '-')
-    {
-      dlen = sh_util_base64_dec_alloc (&decoded, 
-				       (unsigned char *)linkpath, 
-				       strlen(linkpath));
-
-      clen = dlen * 2 + 1;
-
-      do {
-	if (decompressed)
-	  SH_FREE(decompressed);
-	clen += dlen; clen_o = clen;
-	decompressed = SH_ALLOC(clen);
-	res = uncompress(decompressed, &clen, decoded, dlen);
-	if (res == Z_MEM_ERROR)
-	  { fprintf(stderr, "%s",_("Error: Not enough memory\n")); return -1; }
-	if (res == Z_DATA_ERROR)
-	  { fprintf(stderr, "%s",_("Error: Data corrupt or incomplete\n")); return -1; }
-      } while (res == Z_BUF_ERROR || clen == clen_o);
-
-      decompressed[clen] = '\0';
-      fputs( (char*) decompressed, stdout);
-      SH_FREE(decompressed);
-      return 0;
-    }
-#else
-  (void) linkpath;
-#endif
-  fprintf(stderr, "%s",_("Error: No data available\n")); 
-  return -1;
+int sh_hash_list_db (char * db_file)
+{
+  sh_file_t * p;
+  SL_TICKET fd;
+  char * line;
+
+  if (!db_file)
+    {
+      _exit(EXIT_FAILURE);
+      return -1; 
+    }
+  if (sl_is_suid())
+    {
+      fprintf(stderr, _("ERROR: insufficient privilege\n"));
+      _exit (EXIT_FAILURE);
+      return -1; /* for Mac OSX compiler */
+    }
+  if (0 == strcmp(db_file, _("default")))
+    db_file = file_path('D', 'W');
+  if (!db_file)
+    {
+      _exit(EXIT_FAILURE);
+      return -1; 
+    }
+
+  line = SH_ALLOC(MAX_PATH_STORE+1);
+
+  if ( SL_ISERROR(fd = sl_open_read(db_file, SL_YESPRIV))) 
+    {
+      fprintf(stderr, _("ERROR: can't open %s for read (errnum = %ld)\n"), 
+	      db_file, fd);
+      _exit(EXIT_FAILURE);
+      return -1; 
+    }
+
+  /* fast forward to start of data
+   */
+  sh_hash_setdataent(fd, line, MAX_PATH_STORE, db_file);
+
+  while (1) 
+    {
+      p = sh_hash_getdataent (fd, line, MAX_PATH_STORE);
+      if ((p != NULL) && (p->fullpath[0] != 'K'))
+	{
+	  if (ListFullDetail == S_FALSE)
+	    sh_hash_list_db_entry (p); 
+	  else
+	    sh_hash_list_db_entry_full_detail (p); 
+	}
+      else if (p == NULL)
+	{
+	  break;
+	}
+    }
+
+  if (line != NULL)
+    SH_FREE(line);
+  sl_close (fd);
+
+  fflush(NULL);
+
+  _exit(EXIT_SUCCESS);
+  return 0; 
 }
 
Index: /trunk/src/sh_html.c
===================================================================
--- /trunk/src/sh_html.c	(revision 584)
+++ /trunk/src/sh_html.c	(revision 1)
@@ -24,10 +24,14 @@
 #include <stdlib.h>
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
+#else
+#include <time.h>
 #endif
-#include <time.h>
-
-#include <unistd.h>
+#endif
 
 
@@ -36,5 +40,5 @@
 
 #include "samhain.h"
-#include "sh_xfer.h"
+#include "sh_forward.h"
 #include "sh_error.h"
 #include "sh_unix.h"
@@ -86,7 +90,4 @@
   time_t    now;
   struct tm   * time_ptr;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-  struct tm    time_tm;
-#endif
 
   char    * formatted;
@@ -101,5 +102,5 @@
   if (p)
     {
-      fd = sl_open_read (FIL__, __LINE__, p, SL_YESPRIV);
+      fd = sl_open_read (p, SL_YESPRIV);
       SH_FREE(p);
     }
@@ -107,5 +108,5 @@
   if (!SL_ISERROR(fd))
     {
-      while (!SL_ISERROR(status) && sh_unix_getline (fd, line, sizeof(line)) > 0) 
+      while (!SL_ISERROR(status) && sh_unix_getline (fd, line, 511) > 0) 
 	{
 	  formatted = replace_stat (line);
@@ -120,5 +121,5 @@
   else
     {
-      qstr = sh_util_basename(DEFAULT_HTML_FILE);
+      qstr = sh_util_filename(DEFAULT_HTML_FILE);
       if (qstr != NULL)
 	{
@@ -147,23 +148,11 @@
       if (!SL_ISERROR(status))
 	{
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-	  time_ptr   = localtime_r (&(server_status.start), &time_tm);
-#else
 	  time_ptr   = localtime (&(server_status.start));
-#endif
 	  if (time_ptr != NULL) 
-	    strftime (ts1, 80, _("%d-%m-%Y %H:%M:%S"), time_ptr);
-	  else
-	    sl_strlcpy(ts1, _("01-01-1970 00:00:00"), sizeof(ts1));
+	    status = strftime (ts1, 80, _("%d-%m-%Y %H:%M:%S"), time_ptr);
 	  now = time(NULL);
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-	  time_ptr   = localtime_r (&now, &time_tm);
-#else
 	  time_ptr   = localtime (&now);
-#endif
 	  if (time_ptr != NULL) 
-	    strftime (ts2, 80, _("%d-%m-%Y %H:%M:%S"), time_ptr);
-	  else
-	    sl_strlcpy(ts2, _("01-01-1970 00:00:00"), sizeof(ts2));
+	    status = strftime (ts2, 80, _("%d-%m-%Y %H:%M:%S"), time_ptr);
 
 	  sl_snprintf(outline, 1023, 
@@ -185,13 +174,7 @@
 	  if (server_status.last > (time_t) 0)
 	    {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-	      time_ptr   = localtime_r (&(server_status.last), &time_tm);
-#else
 	      time_ptr   = localtime (&(server_status.last));
-#endif
 	      if (time_ptr != NULL) 
-		strftime (ts1, 80, _("%d-%m-%Y %H:%M:%S"), time_ptr);
-	      else
-		sl_strlcpy(ts1, _("01-01-1970 00:00:00"), sizeof(ts1));
+		status = strftime (ts1, 80, _("%d-%m-%Y %H:%M:%S"), time_ptr);
 	      sl_snprintf(outline, 1023, 
 			  _("<p>Last connection at %s</p>"), 
@@ -228,5 +211,5 @@
   if (p)
     {
-      fd = sl_open_read (FIL__, __LINE__, p, SL_YESPRIV);
+      fd = sl_open_read (p, SL_YESPRIV);
       SH_FREE(p);
     }
@@ -234,5 +217,5 @@
   if (!SL_ISERROR(fd))
     {
-      while (!SL_ISERROR(status) && sh_unix_getline (fd, line, sizeof(line)) > 0) 
+      while (!SL_ISERROR(status) && sh_unix_getline (fd, line, 511) > 0) 
 	{
 	  status = sl_write_line (ticket, line, sl_strlen(line));
@@ -278,5 +261,5 @@
 
 static
-int sh_html_get_entry (void)
+int sh_html_get_entry ()
 {
   long      retval = SL_ENONE;
@@ -301,10 +284,10 @@
   if (p)
     {
-      fd = sl_open_read (FIL__, __LINE__, p, SL_YESPRIV);
+      fd = sl_open_read (p, SL_YESPRIV);
       SH_FREE(p);
     }
   if (!SL_ISERROR(fd))
     {
-      while (!SL_ISERROR(retval) && sh_unix_getline (fd, line, sizeof(line)) > 0) 
+      while (!SL_ISERROR(retval) && sh_unix_getline (fd, line, 511) > 0) 
 	{
 	  line_size = sl_strlen(line);
@@ -312,28 +295,22 @@
 	  if (entry_orig != NULL)
 	    {
-	      char * ptr = realloc(entry_orig,           /* free() ok     */
-				   entry_size + line_size + 1);
-	      if (ptr) {
-		entry_orig = ptr;
-		add_size = line_size; 
-	      } else {
-		{ free(entry_orig); entry_orig = NULL; }
-	      }
+	      entry_orig = realloc(entry_orig,           /* free() ok     */
+				   entry_size + line_size);
+	      if (entry_orig) { add_size = line_size; }
 	    }
 	  else
 	    {
-	      entry_orig = calloc(1, line_size + 1);        /* free() ok     */
-	      if (entry_orig) { entry_orig[0] = '\0'; add_size = line_size; }
+	      entry_orig = malloc(line_size + 1);        /* free() ok     */
+	      if (entry_orig) { entry_orig[0] = '\0'; add_size = line_size + 1; }
 	    }
 	  if (!entry_orig)
 	    {
 	      entry_size = 0;
-	      /* add_size   = 0; *//* never read */
+	      add_size   = 0;
 	      SL_RETURN( 0, _("sh_html_get_entry"));
 	    }
 
-	  sl_strlcat(&entry_orig[entry_size], line, line_size + 1);
+	  strcat(&entry_orig[entry_size], line);         /* known to fit  */
 	  entry_size += add_size;
-	  SH_VALIDATE_EQ(entry_orig[entry_size], '\0');
 	}
       sl_close(fd);
@@ -396,6 +373,6 @@
 int comp_arr (const void * ao, const void * bo)
 {
-  const sort_arr * a;
-  const sort_arr * b;
+  sort_arr * a;
+  sort_arr * b;
 
   if (ao == NULL && bo == NULL)
@@ -406,6 +383,6 @@
     return (1);
 
-  a = (const sort_arr *) ao;
-  b = (const sort_arr *) bo;
+  a = (sort_arr *) ao;
+  b = (sort_arr *) bo;
 
   return ((-1) * sl_strcmp(a->tim, b->tim));
@@ -417,5 +394,5 @@
   int status;
   int clt_status;
-  unsigned int i, n;
+  int i, n;
 
   SL_ENTER(_("sh_html_print_one"));
@@ -487,5 +464,5 @@
 
 
-  fd = sl_open_write_trunc (FIL__, __LINE__, DEFAULT_HTML_FILE, SL_YESPRIV);
+  fd = sl_open_write_trunc (DEFAULT_HTML_FILE, SL_YESPRIV);
 
   if (SL_ISERROR(fd))
@@ -509,30 +486,4 @@
 }
 
-int sh_html_zero()
-{
-  long fd;
-
-  SL_ENTER(_("sh_html_zero"));
-
-  if (0 != (fd = tf_trust_check (DEFAULT_HTML_FILE, SL_YESPRIV)))
-    {
-      SL_RETURN((-1), _("sh_html_zero"));
-    }
-
-  fd = sl_open_write_trunc (FIL__, __LINE__, DEFAULT_HTML_FILE, SL_YESPRIV);
-
-  if (SL_ISERROR(fd))
-    {
-     SL_RETURN((-1), _("sh_html_zero"));
-    }
-
-  sh_html_head(fd);
-  sh_html_foot(fd);
-
-  sl_close(fd);
-
-  SL_RETURN((0), _("sh_html_zero"));
-}
-
 /* SH_WITH_SERVER */
 #endif
Index: /trunk/src/sh_ignore.c
===================================================================
--- /trunk/src/sh_ignore.c	(revision 584)
+++ /trunk/src/sh_ignore.c	(revision 1)
@@ -33,6 +33,4 @@
 #endif
 
-#include <string.h>
-
 #include "samhain.h"
 #include "sh_mem.h"
@@ -40,6 +38,4 @@
 
 #define FIL__ _("sh_ignore.c")
-
-#if defined(SH_WITH_CLIENT) || defined(SH_STANDALONE)
 
 struct sh_ignore_list {
@@ -55,13 +51,9 @@
 static struct sh_ignore_list * sh_del_ign = NULL;
 static struct sh_ignore_list * sh_new_ign = NULL;
-static struct sh_ignore_list * sh_mod_ign = NULL;
 
 static struct sh_ignore_list * sh_ignore_add_int(struct sh_ignore_list * list, 
-						 const char * addpath)
+						 char * addpath)
 {
   struct sh_ignore_list * new;
-  char                  * reg_expr;
-  size_t                  len;
-
 #ifdef HAVE_REGEX_H
   int                     status = -1;
@@ -73,18 +65,13 @@
   SL_ENTER(_("sh_ignore_add"));
 
-  if ( (addpath == NULL) || (sl_ok_adds(2, strlen(addpath)) == S_FALSE) )
+  if (addpath == NULL)
     {
       SL_RETURN(list, _("sh_ignore_add"));
     }
 
-  new      = SH_ALLOC(sizeof(struct sh_ignore_list));
-
-  len      = 2 + strlen(addpath);
-  reg_expr = SH_ALLOC(len);
-  sl_strlcpy(reg_expr,     "^", len);
-  sl_strlcat(reg_expr, addpath, len);
+  new  = SH_ALLOC(sizeof(struct sh_ignore_list));
 
 #ifdef HAVE_REGEX_H
-  status = regcomp(&(new->preg), reg_expr, REG_NOSUB|REG_EXTENDED);
+  status = regcomp(&(new->preg), addpath, REG_NOSUB|REG_EXTENDED);
   if (status != 0)  
     {
@@ -93,8 +80,7 @@
       errbuf[BUFSIZ] = '\0';
       sh_error_handle ((-1), FIL__, __LINE__, status, MSG_E_REGEX,
-                       errbuf, reg_expr);
+                       errbuf, addpath);
       SH_FREE(errbuf);
       SH_FREE(new);
-      SH_FREE(reg_expr);
       SL_RETURN(list, _("sh_ignore_add"));
     }
@@ -105,5 +91,4 @@
 #endif
 
-  SH_FREE(reg_expr);
   new->next = list;
 
@@ -111,5 +96,5 @@
 }
 
-int sh_ignore_add_del (const char * addpath)
+int sh_ignore_add_del (char * addpath)
 {
   if ((addpath == NULL) || (addpath[0] != '/'))
@@ -121,5 +106,5 @@
 }
 
-int sh_ignore_add_new (const char * addpath)
+int sh_ignore_add_new (char * addpath)
 {
   if ((addpath == NULL) || (addpath[0] != '/'))
@@ -128,14 +113,4 @@
     }
   sh_new_ign = sh_ignore_add_int (sh_new_ign, addpath);
-  return 0;
-}
-
-int sh_ignore_add_mod (const char * addpath)
-{
-  if ((addpath == NULL) || (addpath[0] != '/'))
-    {
-      return -1;
-    }
-  sh_mod_ign = sh_ignore_add_int (sh_mod_ign, addpath);
   return 0;
 }
@@ -182,10 +157,5 @@
 }
 
-int sh_ignore_chk_mod (const char * chkpath)
-{
-  return (sh_ignore_chk_int(sh_mod_ign, chkpath));
-}
-
-int sh_ignore_clean (void)
+int sh_ignore_clean ()
 {
   struct sh_ignore_list * new;
@@ -219,112 +189,10 @@
     }
 
-  new = sh_mod_ign;
-
-  while (new)
-    {
-      sh_mod_ign = new->next;
-#ifdef HAVE_REGEX_H
-      regfree (&(new->preg));
-#else
-      SH_FREE(new->path);
-#endif
-      SH_FREE(new);
-      new        = sh_mod_ign;
-    }
-
   return 0;
 }
-#endif
 
-#ifdef SH_CUTEST
-#include "CuTest.h"
 
-void Test_ignore_ok (CuTest *tc) {
-#if defined(SH_WITH_CLIENT) || defined(SH_STANDALONE)
 
-  int ret; 
 
-  CuAssertTrue(tc, NULL == sh_del_ign);
-  CuAssertTrue(tc, NULL == sh_new_ign);
-  CuAssertTrue(tc, NULL == sh_mod_ign);
- 
-  ret = sh_ignore_add_del ("/var/log/foo/.*");
-  CuAssertTrue(tc, 0 == ret);
 
-  CuAssertPtrNotNull(tc, sh_del_ign);
-  CuAssertTrue(tc, NULL == sh_new_ign);
-  CuAssertTrue(tc, NULL == sh_mod_ign);
 
-  ret = sh_ignore_chk_del ("/var/log/foo/test");
-  CuAssertTrue(tc, S_TRUE == ret);
-  
-  ret = sh_ignore_chk_del ("/var/log/footest");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  ret = sh_ignore_chk_del ("/my/var/log/footest");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  ret = sh_ignore_chk_del ("/my/var/log/foo/test");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  sh_ignore_clean();
-  CuAssertTrue(tc, NULL == sh_del_ign);
-  CuAssertTrue(tc, NULL == sh_new_ign);
-  CuAssertTrue(tc, NULL == sh_mod_ign);
- 
-  ret = sh_ignore_add_new ("/var/log/foo/.*");
-  CuAssertTrue(tc, 0 == ret);
-
-  CuAssertPtrNotNull(tc, sh_new_ign);
-  CuAssertTrue(tc, NULL == sh_del_ign);
-  CuAssertTrue(tc, NULL == sh_mod_ign);
-
-  ret = sh_ignore_chk_new ("/var/log/foo/test");
-  CuAssertTrue(tc, S_TRUE == ret);
-  
-  ret = sh_ignore_chk_new ("/var/log/footest");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  ret = sh_ignore_chk_new ("/my/var/log/footest");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  ret = sh_ignore_chk_new ("/my/var/log/foo/test");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  sh_ignore_clean();
-  CuAssertTrue(tc, NULL == sh_new_ign);
-  CuAssertTrue(tc, NULL == sh_del_ign);
-  CuAssertTrue(tc, NULL == sh_mod_ign);
-
-  ret = sh_ignore_add_mod ("/var/log/foo/.*");
-  CuAssertTrue(tc, 0 == ret);
-
-  CuAssertPtrNotNull(tc, sh_mod_ign);
-  CuAssertTrue(tc, NULL == sh_del_ign);
-  CuAssertTrue(tc, NULL == sh_new_ign);
-
-  ret = sh_ignore_chk_mod ("/var/log/foo/test");
-  CuAssertTrue(tc, S_TRUE == ret);
-  
-  ret = sh_ignore_chk_mod ("/var/log/footest");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  ret = sh_ignore_chk_mod ("/my/var/log/footest");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  ret = sh_ignore_chk_mod ("/my/var/log/foo/test");
-  CuAssertTrue(tc, S_FALSE == ret);
-
-  sh_ignore_clean();
-  CuAssertTrue(tc, NULL == sh_new_ign);
-  CuAssertTrue(tc, NULL == sh_del_ign);
-  CuAssertTrue(tc, NULL == sh_mod_ign);
-
-#else
-  (void) tc; /* fix compiler warning */
-#endif
-  return;
-}
-/* #ifdef SH_CUTEST */
-#endif
-
